#!/bin/bash
. /etc/konahqss/konahqss.inc

timeslices="10!20!25!50!100"
#mtulist="256!512!768!1024!1280!1500"
tones="medium!low!high!highlow" 
janrus="all!jazz!rock!classic!anison!edm!hard rock!heavy metal!live"

timeslice=$(cat /etc/konahqss/timeslice)
#if [ ! -f /etc/konahqss/mtu ]; then
#  mtu="1500"
#else
#  mtu=$(cat /etc/konahqss/mtu)
#fi
if [ ! -f /etc/konahqss/janru ]; then
  janru="all"
  tone="medium"
else
  janru=$(cat /etc/konahqss/janru)
  tone=$(cat /etc/konahqss/tone)
fi
if [ -f /etc/konahqss/ramplayer ]; then
  ramplayer="TRUE"
else
  ramplayer="FALSE"
fi
if [ -f /etc/konahqss/fastmemcpy ]; then
  hqsound="TRUE"
else
  hqsound="FALSE"
fi
if [ -f /etc/konahqss/ramserver ]; then
  ramserver="TRUE"
else
  ramserver="FALSE"
fi
if [ -d /etc/konahqss/soundrivers/$(uname -r) ]; then
  if [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      using="(使用中)"
    else
      using="(used)"
    fi
  fi
  if ([ ! -z "$(pgrep pipewire)" ] || [ ! -z "$(pgrep pulseaudio)" ]) && [ ! -z "$(which systemd 2> /dev/null)" ]; then
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="高音質サウンドドライバーを使う$using:CHK" --field="サーバーをメモリーに置く:CHK" "$janru!$janrus" "$ramplayer" "$hqsound" "$ramserver")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" --field="Use High Quality Sound Driver:CHK" --field="Put the server in RAM" "$janru!$janrus" "$ramplayer" "$hqsound" "$ramserver")
    fi
  else
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="高音質サウンドドライバーを使う$using:CHK" "$janru!$janrus" "$ramplayer" "$hqsound")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" --field="Use High Quality Sound Driver:CHK" "$janru!$janrus" "$ramplayer" "$hqsound")
    fi
  fi
else
  if ([ ! -z "$(pgrep pipewire)" ] || [ ! -z "$(pgrep pulseaudio)" ])  && [ ! -z "$(which systemd 2> /dev/null)" ]; then
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="サーバーをメモリーに置く:CHK" "$janru!$janrus" "$ramplayer" "$ramserver")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" --field="Put the server in RAM:CHK" "$janru!$janrus" "$ramplayer")
    fi
  else
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" "$janru!$janrus" "$ramplayer")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" "$janru!$janrus" "$ramplayer")
    fi
  fi
fi
rcd="$?"
if [ "$rcd" = "0" ]; then
  janru=$(echo $ret|cut -d'|' -f1)
  case $janru in
    "all") tone="medium";;
    "jazz") tone="medium"
	    baseboost="true";;
    "classic") tone="low";;
    "live") tone="highlow";;
    "anison") tone="high";;
    "edm" | "rock") tone="high"
            baseboost="true";;
    "hard rock") tone="highlow"
            baseboost="true";;
    "heavy metal") tone="low"
            baseboost="true";;
  esac
  echo $tone > /etc/konahqss/tone
  if [ ! -z "$(echo tone|grep low)" ]; then
    echo 8192 > /etc/konahqss/rmem
  else
    rm -f /etc/konahqss/rmem
  fi
  echo $janru > /etc/konahqss/janru
  if [ "$baseboost" = "true" ]; then
    touch /etc/konahqss/baseboost
  else
    rm -f /etc/konahqss/baseboost
  fi
  if [ "$(echo $ret|cut -d'|' -f2)" = "TRUE" ]; then
    touch /etc/konahqss/ramplayer
  else
    rm -f /etc/konahqss/ramplayer
  fi
  if [ -d /etc/konahqss/soundrivers/$(uname -r) ]; then
    if [ "$(echo $ret|cut -d'|' -f3)" = "TRUE" ]; then
      touch /etc/konahqss/fastmemcpy
      if [ ! -z "$(locale|grep ja_JP)" ]; then
        zenity --warning --title="サウンドの設定" --text="高音質サウンドドライバーを使うときは\nセキュアブートをオフにしてください" --no-wrap
      else
        zenity --warning --title="Sound Settings" --text="Turn off secure boot when using high quality sound drivers" --no-wrap
      fi
    else
      rm -f /etc/konahqss/fastmemcpy
    fi
    ramserver=$(echo $ret|cut -d'|' -f4)
  else
    ramserver=$(echo $ret|cut -d'|' -f3)
  fi
  rm -f /etc/konahqss/ramserver
  if [ ! -z "$ramserver" ]; then
    if [ "$ramserver" = "TRUE" ]; then
      touch /etc/konahqss/ramserver
    fi
  fi
  if [ ! -z "$(locale|grep ja_JP)" ]; then
    zenity --info --title="サウンドの設定" --text="サウンドを設定しました\nシステムを再起動すると有効になります。" --no-wrap
  else
    zenity --info --title="Sound Settings" --text="Completed setting the sound\nIt will take effect when the system is restarted" --no-wrap
  fi
fi

